{
Die Butter ist ein Modul, das auf Kommando hin zu einer Koordinate fliegt
}
VAR
  byte  ID_cog                        ' Id des lokalen Cogs
  long  Sk[60]                        ' Stack des Cogs



PUB Start( GlobPtr, AddrOffs) | i

  Stop  ' Start can restart, therefore stop a possibly running cog first
  ' Create a local copy of the global pointer array and do the address correction "quick and dirty"
  repeat i from 0 to LONG[LONG[GlobPtr +   0]+AddrOffs]-1        ' The first parameter is the number of parameters
    LONG[@LoclPtr + (i<<2)] := LONG[GlobPtr + (i<<2)] + AddrOffs ' all pointers are 32 bit, the pointer address is byte oriented

  ifnot ID_cog
    ID_cog := cognew(CogProc, @Sk) + 1
  Result := ID_Cog

PRI Stop
  if ID_cog
    cogstop(ID_cog~ - 1)

CON
'Allen Prozessen gemeinsame Kommandos:
  #1, Idle, Run
'Die diesem Prozess eigenen Kommandos:
  #3, Funktion1

PRI CogProc  | i, LocCmd

'LoclPtr ist der Zeiger auf den Prozessdatenblock mit den Adressen der Variablen

  ' Hier nun noch vorbereitende Ttigkeiten
  XBttrNeu      := Long[XBttrNeuPtr ]
  YBttrNeu      := Long[YBttrNeuPtr ]   '
  XBttrMini     := Long[XBttrMiniPtr]   '
  XBttrMaxi     := Long[XBttrMaxiPtr]
  YBttrMini     := Long[YBttrMiniPtr]   '
  YBttrMaxi     := Long[YBttrMaxiPtr]
  dXBttr__      := Long[dXBttr__Ptr]
  dYBttr__      := Long[dYBttr__Ptr]

  Long[BttrDispPtr] := 2

  Long[CommandPtr]  := 0         ' Acknowlegde Command to show: Cog is running

  Repeat         ' Eine Endlosschleife

    repeat while (LocCmd := Long[CommandPtr]) == 0 ' Ein Kommando erwarten

    case LocCmd

      Idle: ' !Muss auch im Idle-Zustand erkannt werden
        Long[CommandPtr] := 0 ' Kommando besttigen, bin Idle

      Run: ' Zum neuen Platz hin fliegen
        Long[CommandPtr] := 0 ' Kommando besttigen
        'Initiale Aktivitten
        Long[YBttrNeuPtr] :=  Long[YWrfrNeuPtr]

        repeat while Long[CommandPtr] <> 1 ' Solange kein Idle kommt:
          ' Kontinuierlicher Prozess, round and round

            XBttrAlt  :=  XBttrNeu
            YBttrAlt  :=  YBttrNeu

            XBttrNeu  += dXBttr__
            YBttrNeu  += dYBttr__
            if (XBttrNeu =< XBttrMini) or (XBttrNeu => XBttrMaxi)
               dXBttr__ := -dXBttr__
            if (YBttrNeu =< YBttrMini) or (YBttrNeu => YBttrMaxi)
               dYBttr__ := -dYBttr__
            repeat while Long[BttrDispPtr]   ' Warten bis Display Darstellung besttigt

            Long[XBttrAltPtr] := XBttrAlt
            Long[YBttrAltPtr] := YBttrAlt
            Long[XBttrNeuPtr] := XBttrNeu
            Long[YBttrNeuPtr] := YBttrNeu

            Long[BttrDispPtr] := 1 ' Zeigen, dass Wert dargestellt werden soll

'

DAT
{{
 Hier stehen nun alle Zeiger auf die Variablen im globlen Speicher, die fr diesen Prozess relevant sind.
 Sie sind in der gleichen Folge abgelegt wie im Prozessparameterblock
}}

LoclPtr
CommandPtr  long  0   ' Zeiger auf das Kommando fr diesen Prozess
BttrDispPtr  long  0
XBttrAltPtr  Long  0
YBttrAltPtr  Long  0
XBttrNeuPtr  Long  0
YBttrNeuPtr  Long  0
dXBttr__Ptr  Long  0
dYBttr__Ptr  Long  0
YWrfrNeuPtr  Long  0
XBttrMiniPtr  Long  0
XBttrMaxiPtr  Long  0
YBttrMiniPtr  Long  0
YBttrMaxiPtr  Long  0
BttrColoPtr  Long  0

BttrCmd  long  0   ' Zeiger auf das Kommando fr diesen Prozess
BttrDisp  long  0
XBttrAlt  Long  0
YBttrAlt  Long  0
XBttrNeu  Long  0
YBttrNeu  Long  0
dXBttr__  Long  0
dYBttr__  Long  0
YWrfrNeu  Long  0
XBttrMini  Long  0
XBttrMaxi  Long  0
YBttrMini  Long  0
YBttrMaxi  Long  0
BttrColo  Long  0

'-----------------------------------------