{
Der Werfer ist ein Modul, das auf Kommando hin die Butter wirft
Dazu luft er hoch und runter mit der Butter und ein Trigger lst dann den Butter-Prozess aus,
Dann lst sich die Butter vom Werfer und fliegt richtung Fnger.

}
VAR
  byte  ID_cog                        ' Id des lokalen Cogs
  long  Sk[60]                        ' Stack des Cogs

PUB Start( GlobPtr, AddrOffs) | i

  Stop  ' Start can restart, therefore stop a possibly running cog first
  ' Create a local copy of the global pointer array and do the address correction "quick and dirty"
  repeat i from 0 to LONG[LONG[GlobPtr +   0]+AddrOffs]-1        ' The first parameter is the number of parameters
    LONG[@LoclPtr + (i<<2)] := LONG[GlobPtr + (i<<2)] + AddrOffs ' all pointers are 32 bit, the pointer address is byte oriented

  ifnot ID_cog
    ID_cog := cognew(CogProc, @Sk) + 1
  Result := ID_Cog

PRI Stop
  if ID_cog
    cogstop(ID_cog~ - 1)

CON
'Allen Prozessen gemeinsame Kommandos:
  #1, Idle, Run
'Die diesem Prozess eigenen Kommandos:
  #3, Funktion1

PRI CogProc  | i, LocCmd

'LoclPtr ist der Zeiger auf den Prozessdatenblock mit den Adressen der Variablen

  ' Hier nun noch vorbereitende Ttigkeiten
  XWrfrNeu      := Long[XWrfrNeuPtr ]
  YWrfrNeu      := Long[YWrfrNeuPtr ]   '
  XBttrNeu      := Long[XBttrNeuPtr ]
  YBttrNeu      := Long[YBttrNeuPtr ]   '
  YWrfrMini     := Long[YWrfrMiniPtr]   '
  YWrfrMaxi     := Long[YWrfrMaxiPtr]

  Long[WrfrDispPtr] := 2

  Long[CommandPtr]  := 0         ' Acknowlegde Command to show: Cog is running

  Repeat         ' Eine Endlosschleife

    repeat while (LocCmd := Long[CommandPtr]) == 0 ' Ein Kommando erwarten

    case LocCmd

      Idle: ' !Muss auch im Idle-Zustand erkannt werden
        Long[CommandPtr] := 0 ' Kommando besttigen, bin Idle

      Run: ' Zum neuen Platz hin fliegen
        Long[CommandPtr] := 0 ' Kommando besttigen
        'Initiale Aktivitten
        i := 5

        repeat while Long[CommandPtr] <> Idle ' Solange kein Idle kommt:
          ' Kontinuierlicher Prozess, round and round
            repeat while Long[WrfrDispPtr]   ' Warten bis Display Darstellung besttigt

            YWrfrAlt := YWrfrNeu
            YWrfrNeu += i
            if (YWrfrNeu =< YWrfrMini) or (YWrfrNeu => YWrfrMaxi)
               i := -i

            Long[YWrfrAltPtr] := YWrfrAlt
            Long[YWrfrNeuPtr] := YWrfrNeu
            Long[WrfrDispPtr] := 1 ' Zeigen, dass Wert dargestellt werden soll

'            waitcnt (cnt + 180_000_000)  ' eine Sekunde warten

DAT
{{
 Hier stehen nun alle Zeiger auf die Variablen im globlen Speicher, die fr diesen Prozess relevant sind.
 Sie sind in der gleichen Folge abgelegt wie im Prozessparameterblock
}}

LoclPtr
CommandPtr    long  0   ' Zeiger auf das Kommando fr diesen Prozess
WrfrDispPtr   long  0
XWrfrAltPtr   long  0
YWrfrAltPtr   long  0
XWrfrNeuPtr   long  0
YWrfrNeuPtr   long  0
XBttrNeuPtr   long  0   ' ACHTUNG: das sind alles Pointer auf entsprechende Variablen in Global!
YBttrNeuPtr   long  0

YWrfrMiniPtr  long  0   ' Minimaler Wert Fngerposition
YWrfrMaxiPtr  long  0   ' Maximaler Wert Fngerposition
WrfrColoPtr   long  0   ' Farbe des Fngers
'-----------------------------------------

WrfrCmd       long  0   ' Lokales Kommando fr den Fnger
WrfrColo      long  0   'Farbe des Fngers
WrfrDisp      long  0
XWrfrAlt      long  0
YWrfrAlt      long  0   '
XWrfrNeu      long  0
YWrfrNeu      long  0   '
XBttrNeu      long  0

YBttrNeu      long  0   '
YWrfrMini     long  0   '
YWrfrMaxi     long  0