{{ Wirf mir mal die Butter rber, Please throw me the butter}}

{{
Demonstration eines Aufrufschemas fr Prozesse und ihre Kommunikation.

Dokumentation in CMap "DieButter"

Das Hauptprogramm definiert einen Pool von Daten.

Es werden verschiedene Prozesse gestartet, die einen Zeiger erhalten, der auf einen Prozesscontrolblock
verweist. Der Block besteht aus Zeigern auf Variable. Die erste Variable ist das Prozesskommando.

Die weiteren sind programmspezifisch und ihre Bedeutung muss bekannt sein.
Die Kommunikation zwischen den Prozessen erfolgt nach einen einfachen Schema:

  Ist das Kommando fr Prozess N auf dem Wert 0, kann es beschrieben werden.
  Kennt man den Zustand des Prozesses N nicht, empfiehlt sich das Kommanodo "Idle". Damit wird der
  Prozess N in den Ruhezustand gebracht. Dieser ist gegeben, wenn das Kommando mit 0 quittiert wird.

  Dieses Protokoll funktioniert nur, wenn klar ist, wer wem Kommandos gibt und es keine berschneidungen
  gibt. Ansonsten muss man Semaphoren einbauen!

  Der Prozess N kennt zwei grundlegende Arbeitsweisen: Ein Kommando wird erkannt und ausgefhrt, danach
  ist der Prozess wieder Idle. Wird die Quittung nach Abschluss gegeben ist damit sichergestellt, dass
  auch die Eingangsvariablen wieder frei sind.
  Weise zwei: Kommando wird erkannt, Parameter werden bernommen, Kommando quittiert und dann eine Funktion
  so lange ausgefhrt, bis eine Endebedingung oder ein Idle-Kommando erkannt wird.

  Daneben gibt es noch eine dritte Weise: man macht es so, wie man gerade Lust hat.

2025_02_12_na: first presentation to the forum
2025_02_07_na: PCB umgestellt auf long und Adresskorrektur in Start
2025_02_06_na: Wieder aufgenommen
}}



CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

'Allen Prozessen gemeinsame Kommandos:
  #1, Idle, Run, Disp


'Fr die Visualisierung unter Windows: PC-Interface & Graphik
  #0, WHITE,CYAN,RED,PINK,BLUE,GREEN,YELLOW,GRAY        'Standard colors


' Visualisierung
  ColA = red
  ColB = green
  ColC = blue
  ColD = yellow
  ColE = cyan
  ColF = pink
  ColG = white
  ColH = white


OBJ

  term     : "PCAscii_Interface"  ' Graphik (0,0) links oben
  Wrfr     : "Werfer"             ' Ein Butterwerfer
  Bttr     : "Butter"             ' Die Butter
  Fngr     : "Faenger"            ' Der Fnger

VAR
  long   ch
DAT
VersDate byte  "12.02.2025 A na", 0




MsgCol       long  Yellow  ' Voreingestellte Farbe  fr eine Message
MsgXpo       long  5       ' Voreingestellte Spalte fr eine Message
MsgYpo       long  31      ' Voreingestellte Zeile  fr eine Message


CON      AnzBttrPar = 14 ' Wertezeiger fr die Butter
'Dat ProzBttr long  @BttrCmd, @BttrDisp, @XBttrNeu, @YBttrNeu, @dXBttr, @dYBttr, @YWrfrNeu
Dat ProzBttr long  @BttrCmd,   @BttrDisp,  @XBttrAlt,  @YBttrAlt,  @XBttrNeu,  @YBttrNeu, @dXBttr, @dYBttr
             long  @YWrfrNeu,  @XBttrMini, @XBttrMaxi, @YBttrMini, @YBttrMaxi, @BttrColo , 0, 0, 0, 0

CON      AnzWrfrPar = 11 ' Wertezeiger fr den Fnger
Dat ProzWrfr long  @WrfrCmd,   @WrfrDisp, @XWrfrAlt, @YWrfrAlt, @XWrfrNeu, @YWrfrNeu, @XBttrNeu, @YBttrNeu
             long  @YWrfrMini, @YWrfrMaxi, @WrfrColo , 0, 0, 0, 0

CON      AnzFngrPar = 11 ' Wertezeiger fr den Fnger
Dat ProzFngr long  @FngrCmd,   @FngrDisp, @XFngrAlt, @YFngrAlt, @XFngrNeu, @YFngrNeu, @XBttrNeu, @YBttrNeu
             long  @YFngrMini, @YFngrMaxi, @FngrColo , 0, 0, 0, 0

BttrCmd     long  0    ' prozess Kommando
WrfrCmd     long  0
FngrCmd     long  0




FngrDisp    long  0     '
FngrColo    long  white'Green    ' Fnger Farbe
XFngrAlt    long 410     ' Alte X-koordinate des Fngers
XFngrNeu    long 410     ' Neue X-koordinate des Fngers
YFngrAlt    long 100     ' Alte Y-koordinate des Fngers
YFngrNeu    long 100     ' Neue Y-koordinate des Fngers
XFngrSize   long 12     ' Breite des Fngers
YFngrSize   long  8     ' Hhe des Fngers
YFngrMini   long  50    ' Minimalwert Fnger
YFngrMaxi   long 250    ' Maximalwert Fnger

WrfrDisp    long  0     '
WrfrColo    long  white'Red   ' Werfer Farbe
XWrfrAlt    long 50     ' Alte X-koordinate der Butter
XWrfrNeu    long 50     ' Neue X-koordinate der Butter
YWrfrAlt    long 100     ' Alte Y-koordinate der Butter
YWrfrNeu    long 100    ' Neue Y-koordinate der Butter
XWrfrSize   long 12     ' Breite der Butter
YWrfrSize   long 20     ' Hhe der Butter
YWrfrMini   long  50    ' Minimalwert Werfer
YWrfrMaxi   long 250    ' Maximalwert Werfer

BttrDisp    long  0     ' >0 Bttr bereit, display , von Min zurckgesetzt
BttrColo    long  white'Yellow' Butter Farbe
XBttrAlt    long 20     ' Alte X-koordinate der Butter
XBttrNeu    long 20     ' Neue X-koordinate der Butter
YBttrAlt    long 20     ' Alte Y-koordinate der Butter
YBttrNeu    long 20     ' Neue Y-koordinate der Butter
XBttrSize   long 12     ' Breite der Butter
YBttrSize   long 12     ' Hhe der Butter
XBttrMini   long  20    ' Minimalwert Butter
XBttrMaxi   long 450    ' Maximalwert Butter
YBttrMini   long  20    ' Minimalwert Butter
YBttrMaxi   long 280    ' Maximalwert Butter

dXWrfr      long  0     ' nderung X-koordinate der Butter
dYWrfr      long  10     ' nderung Y-koordinate der Butter

dXFngr      long  0     ' nderung X-koordinate der Butter
dYFngr      long  1     ' nderung Y-koordinate der Butter
dXBttr      long  10     ' nderung X-koordinate der Butter
dYBttr      long  20    ' nderung Y-koordinate der Butter




' Folgende Daten zur Dokumentation von Zeit und Datum des Programmlaufes
Time        long  0   ' Counter als aktuelle Zeit
TimeStrg    byte  0, 0, 0, 0, 0, 0, 0, 0, 0
DateStrg    byte  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
TimeRequ    byte  5, $81, 2, 2, 0
DateRequ    byte  5, $81, 3, 3, 0
StV001      byte     "18.11.2998", 0, "b8.11.2998", 0        ' StV001 Datumsstring
StV002      byte     "13:33:34",   0, "b3:33:34",   0        ' StV002 Uhrzeit
LocCol      long   Yellow  ' Farbe, local
LocXpo      long    5      ' X-Korodinate, local
LocYpo      long   31      ' Y-Korodinate, local

PUB Main | TermCOG, AktStat , i


  TermCOG := term.start(31,30)             'start the interface
  term.cls

  repeat while (term.abs_x == 0)    'wait for PropTerminal.exe started

  makeTxtScreen                   ' Bildschirm Text aufbauen, lscht auch Graphik
  DocCog (  CogID+1, String("MainProgramm"))
  DocCog (  TermCOG, String("Terminal   " ))


  ' Zuerst einmal alle Prozesse starten und in Idle laufen lassen
  FngrCmd := AnzFngrPar     ' Damit kann FaengerStart die richtige Anzahl Pointer initialisieren
  i       := Fngr.start(@ProzFngr, @@0) ' Butter starten
  DocCog ( i       , String("Der Fnger  "))

  ' Der Fnger luft nun und hat dem Display mitgeteilt, wo er aktuell platziert ist.
  ' Erster Aufruf von Display stellt das da.

  WrfrCmd := AnzWrfrPar     ' Damit kann WerferStart die richtige Anzahl Pointer initialisieren
  i        := Wrfr.start(@ProzWrfr, @@0) ' Butter starten
  DocCog ( i       , String("Der Werfer  "))

  BttrCmd  := AnzBttrPar     ' Damit kann ButterStart die richtige Anzahl Pointer initialisieren
  i        := Bttr.start(@ProzBttr, @@0) ' Butter starten
  DocCog ( i       , String("Die Butter  "))

   ' Nun den Fnger laufen lassen und immer wieder update
  AktStat := CmdInvoc (@FngrCmd, Run, 0)

  AktStat := CmdInvoc (@WrfrCmd, Run, 0)
  AktStat := CmdInvoc (@BttrCmd, Run, 0)


' DIE HAUPTSCHLEIFE
  repeat 100


    repeat

      Display
      waitcnt(clkfreq/2 + cnt)
      UpDDateTime

Pri  Display | j, AktStat

   WrfrDisp := ObjDisp ( XWrfrAlt, YWrfrAlt, XWrfrNeu, YWrfrNeu, XWrfrSize, YWrfrSize, WrfrDisp, WrfrColo)
   FngrDisp := ObjDisp ( XFngrAlt, YFngrAlt, XFngrNeu, YFngrNeu, XFngrSize, YFngrSize, FngrDisp, FngrColo)
   BttrDisp := ObjDisp ( XBttrAlt, YBttrAlt, XBttrNeu, YBttrNeu, XBttrSize, YBttrSize, BttrDisp, BttrColo)

   ' Datum und Uhrzeit
   LocXpo := 5
   j :=  @StV001

   if NOT StrComp (@byte[j], @byte[j+ StrSize(@byte[j])+ 1])  ' Falls neuer Wert: Ausgabe und Altwert aktualisieren

     CPMessage (LocCol, LocXpo, LocYpo, @byte[j])
     ByteMove (@byte[j+ StrSize(@byte[j])+ 1], @byte[j], StrSize(@byte[j]))

   LocXpo := 20
   j :=  @StV002

   if NOT StrComp (@byte[j], @byte[j+ StrSize(@byte[j])+ 1])  ' Falls neuer Wert: Ausgabe und Altwert aktualisieren

     CPMessage (LocCol, LocXpo, LocYpo, @byte[j])
     ByteMove (@byte[j+ StrSize(@byte[j])+ 1], @byte[j], StrSize(@byte[j]))


PRI ObjDisp (XAlt, YAlt, XNeu, YNeu, XSize, YSize, FlgDisp, Colo) ' Vierecke bewegen
   if FlgDisp
     if FlgDisp == 2
       term.setcol(Colo)
       term.box ( XAlt, YAlt, XSize, YSize)
     else
       term.setcol(colo)
       term.invbox ( XAlt, YAlt, XSize, YSize)
       term.invbox ( XNeu, YNeu, XSize, YSize)

     Result := FlgDisp := 0   ' Display quittiert die Bewegung an Butter



PRI CmdInvoc (CmdPtr, Cmd, Stat) ' Wait until process idle, output cmd, wait for acknowledge, return "Stat" for documentation/debuging purposes
    repeat while long[CmdPtr]
    long[CmdPtr] := Cmd
    repeat while long[CmdPtr]
    Result := Stat

PRI PutStat ( Zust )   ' PutStat gibt den Status aus
    PutVal ( 50,  0,  "#", ":", Zust )
    Result := Zust


PRI DocCog (i, StrPtr)
    CPMessage (Green, 65, 15+i, StrPtr)

PRI MakeTxtScreen  | i
    term.cls
'  term.setcol (0)'(gray)

    DocCog ( 1, String("COG 0 frei"))
    DocCog ( 2, String("COG 1 frei"))
    DocCog ( 3, String("COG 2 frei"))
    DocCog ( 4, String("COG 3 frei"))
    DocCog ( 5, String("COG 4 frei"))
    DocCog ( 6, String("COG 5 frei"))
    DocCog ( 7, String("COG 6 frei"))
    DocCog ( 8, String("COG 7 frei"))

    CPMessage (Yellow,  2, 27, String("Wirf mir mal die Butter rber ! "))
    term.Str  (@VersDate)


PRI PutVal (px, py, Char1, Char2, val1)
    setpos(px, py)
    term.out(Char1)
    term.out(Char2)
    term.dec(val1)



PRI setpos(px, py)

    term.out(10)
    term.out(px)
    term.out(11)
    term.out(py)


PRI CPOut (Col, xpo, ypo, byVal)
    term.setcol(Col)
    setpos     (xpo, ypo)
    term.out   (byVal)      ' Einzelnes Byte ausgeben

'      CPMessage (Green, 35,  3, String("Y"))

PRI CPMessage  (Col, xp, yp, StrPtr)
    setpos     (xp, yp)
    term.setcol(Col)
    term.str   (StrPtr)

PRI PMessage   (xp, yp, StrPtr)
    setpos     (xp, yp)
    term.setcol(MsgCol)
    term.str   (StrPtr)

PRI CMessage   (Col, StrPtr)
    setpos     (MsgXpo, MsgYpo)
    term.setcol(Col)
    term.str   (StrPtr)

PRI Message    (StrPtr)
    PMessage   (MsgXpo, MsgYpo, StrPtr)

PRI UpDDateTime | i

  if DateStrg[0] == 0   ' Das Datum initial, Datum & Uhrzeit vom PC lesen
    term.clearkeys
    term.Str(@TimeRequ)
    i := 0
    repeat while ( ch := term.getkey) <> 13
      TimeStrg[i] := ch
      i++
    term.Str (@DateRequ)
    i := 1
    repeat while ( ch := term.getkey) <> 13
      DateStrg[LookUp(i: 3, 4, 2, 0, 1, 5, 6, 7, 8, 9)] := ch
      i++
    DateStrg[5] := "."
    Time := cnt
    bytemove (@StV001, @DateStrg, StrSize (@StV001))


  if Cnt > Time  ' Alle Sekunde die Zeit aktualisieren und ausgeben
    Time += ClkFreq

    TimeStrg[7] ++
    if TimeStrg[7] == $3A
       TimeStrg[7] := $30

      TimeStrg[6] ++
      if TimeStrg[6] == $36
         TimeStrg[6] := $30

        TimeStrg[4] ++
        if TimeStrg[4] == $3A
           TimeStrg[4] := $30

          TimeStrg[3] ++
          if TimeStrg[3] == $36
             TimeStrg[3] := $30

            TimeStrg[1] ++
            if TimeStrg[1] == $3A OR ((TimeStrg[0] == $32) AND (TimeStrg[1] == $34))
               TimeStrg[1] := $30

              TimeStrg[0] ++
              if (TimeStrg[0] == $33)
                TimeStrg[0] := $30
                TimeStrg[1] := $30

    bytemove (@StV002, @TimeStrg, StrSize (@StV002))


