{
Der Faenger ist ein Modul, das auf Kommando hin die Butter auffngt
}
VAR
  byte  ID_cog                        ' Id des lokalen Cogs
  long  Sk[60]                        ' Stack des Cogs

PUB Start( GlobPtr, AddrOffs) | i

  Stop  ' Start can restart, therefore stop a possibly running cog first
  ' Create a local copy of the global pointer array and do the address correction "quick and dirty"
  repeat i from 0 to LONG[LONG[GlobPtr +   0]+AddrOffs]-1        ' The first parameter is the number of parameters
    LONG[@LoclPtr + (i<<2)] := LONG[GlobPtr + (i<<2)] + AddrOffs ' all pointers are 32 bit, the pointer address is byte oriented

  ifnot ID_cog
    ID_cog := cognew(CogProc, @Sk) + 1
  Result := ID_Cog

PRI Stop
  if ID_cog
    cogstop(ID_cog~ - 1)

CON
'Allen Prozessen gemeinsame Kommandos:
  #1, Idle, Run
'Die diesem Prozess eigenen Kommandos:
  #3, Funktion1

PRI CogProc  | i, LocCmd

'LoclPtr ist der Zeiger auf den Prozessdatenblock mit den Adressen der Variablen

  ' Hier nun noch vorbereitende Ttigkeiten
  XFngrNeu      := Long[XFngrNeuPtr ]
  YFngrNeu      := Long[YFngrNeuPtr ]   '
  XBttrNeu      := Long[XBttrNeuPtr ]
  YBttrNeu      := Long[YBttrNeuPtr ]   '
  YFngrMini     := Long[YFngrMiniPtr]   '
  YFngrMaxi     := Long[YFngrMaxiPtr]

  Long[FngrDispPtr] := 2

  Long[CommandPtr]  := 0         ' Acknowlegde Command to show: Cog is running

  Repeat         ' Eine Endlosschleife

    repeat while (LocCmd := Long[CommandPtr]) == 0 ' Ein Kommando erwarten

    case LocCmd

      Idle: ' !Muss auch im Idle-Zustand erkannt werden
        Long[CommandPtr] := 0 ' Kommando besttigen, bin Idle

      Run: ' Zum neuen Platz hin fliegen
        Long[CommandPtr] := 0 ' Kommando besttigen
        'Initiale Aktivitten
        i := 22

        repeat while Long[CommandPtr] <> Idle ' Solange kein Idle kommt:
          ' Kontinuierlicher Prozess, round and round
            repeat while Long[FngrDispPtr]   ' Warten bis Display Darstellung besttigt

            YFngrAlt := YFngrNeu
            YFngrNeu += i
            if (YFngrNeu =< YFngrMini) or (YFngrNeu => YFngrMaxi)
               i := -i

            Long[YFngrAltPtr] := YFngrAlt
            Long[YFngrNeuPtr] := YFngrNeu
            Long[FngrDispPtr] := 1 ' Zeigen, dass Wert dargestellt werden soll


DAT
{{
 Hier stehen nun alle Zeiger auf die Variablen im globlen Speicher, die fr diesen Prozess relevant sind.
 Sie sind in der gleichen Folge abgelegt wie im Prozessparameterblock
}}

LoclPtr
CommandPtr    long  0   ' Zeiger auf das Kommando fr diesen Prozess
FngrDispPtr   long  0
XFngrAltPtr   long  0
YFngrAltPtr   long  0
XFngrNeuPtr   long  0
YFngrNeuPtr   long  0
XBttrNeuPtr   long  0   ' ACHTUNG: das sind alles Pointer auf entsprechende Variablen in Global!
YBttrNeuPtr   long  0
YFngrMiniPtr  long  0   ' Minimaler Wert Fngerposition
YFngrMaxiPtr  long  0   ' Maximaler Wert Fngerposition
FngrColoPtr   long  0   ' Farbe des Fngers
'-----------------------------------------

FngrCmd       long  0   ' Lokales Kommando fr den Fnger
FngrColo      long  0   'Farbe des Fngers
FngrDisp      long  0
XFngrAlt      long  0
YFngrAlt      long  0   '
XFngrNeu      long  0
YFngrNeu      long  0   '
XBttrNeu      long  0
YBttrNeu      long  0   '
YFngrMini     long  0   '
YFngrMaxi     long  0